package com.api.wishpass2020.wxapi;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.alipay.sdk.app.PayTask;
import com.api.wishpass2020.Constants;
import com.api.wishpass2020.PayResult;
import com.api.wishpass2020.R;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelpay.PayReq;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.IWXAPIEventHandler;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;
import com.unionpay.UPPayAssistEx;


import org.json.JSONObject;

import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Map;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class WXPayEntryActivity extends AppCompatActivity implements IWXAPIEventHandler {
    private static final int SDK_PAY_FLAG = 1;
    private IWXAPI msgApi;
    private EditText editText;
    private OkHttpClient client = new OkHttpClient();
    //private String mMode = "01";
    private String mMode = "00";
    private AppCompatActivity mainActivity;
    private RadioButton radio0;
    private Handler mHandler = new Handler() {
        @SuppressWarnings("unused")
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case SDK_PAY_FLAG: {
                    @SuppressWarnings("unchecked")
                    PayResult payResult = new PayResult((Map<String, String>) msg.obj);
                    String resultInfo = payResult.getResult();
                    String resultStatus = payResult.getResultStatus();
                    // success if resultStatus is 9000
                    if (TextUtils.equals(resultStatus, "9000")) {
                        editText.setText("success:" + payResult);
                        Toast.makeText(WXPayEntryActivity.this, "success:" + payResult,Toast.LENGTH_LONG).show();
                    } else {
                        Toast.makeText(WXPayEntryActivity.this, "fail:"  + payResult,Toast.LENGTH_LONG).show();
                        editText.setText("fail:"  + payResult);
                    }
                    break;
                }

                default:
                    break;
            }
        };
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        msgApi = WXAPIFactory.createWXAPI(this, null);
        editText = findViewById(R.id.editText);
        radio0 = findViewById(R.id.radio0);
        //msgApi.unregisterApp();
        //msgApi.registerApp(Constants.APP_ID_US);
        msgApi.handleIntent(getIntent(), this);
        mainActivity = this;
    }
    public void payWechat(View v){
        String sTo = "WeChat";
        int amount = 1; // unit is cent
        createOrder(sTo,amount);
    }
    public void payAli(View v){
        String sTo = "Ali";
        int amount = 1; // unit is cent
        createOrder(sTo,amount);
    }

    public void payUnionPay(View v){
        String sTo = "UnionPay";
        int amount = 1; // unit is cent
        createOrder(sTo,amount);

    }






    public void createOrder(String sTo, int amount){
        String currency = "CAD";
        String url = Constants.URL;
        //mMode = "01";
        if(radio0 != null && !radio0.isChecked()){
            currency = "USD";
            //url = Constants.URL_USD;
            mMode = "00";
        }
        editText.setText("");
        String channelid = "WX_APP";
        if(sTo.equals("Ali")){
            channelid = "ALIPAY_MOBILE";
        }else if(sTo.equals("UnionPay")){
            channelid = "UPI_APP";
        }else{
            /*if(currency.equals("CAD")){
                msgApi.registerApp(Constants.APP_ID);
            }else{
                msgApi.registerApp(Constants.APP_ID_US);
            }*/


        }
        url += "?channelid=" + channelid+"&amount=" + amount + "&currency=" + currency;

        Request request = new Request.Builder().
                url(url).
                addHeader("User-Agent", "android").
                header("Content-Type", "text/html; charset=utf-8").
                get().
                build();
        if(sTo.equals("Ali")){

            client.newCall(request).enqueue(new Callback() {
                @Override
                public void onFailure(Call call, IOException e) {

                    e.printStackTrace();
                }
                @Override
                public void onResponse(Call call, final Response response) throws IOException {

                    String orderInfo = response.body().string();
                    //orderInfo = "_input_charset=\"utf-8\"&currency=\"USD\"&forex_biz=\"FP\"&it_b_pay=\"2h\"&notify_url=\"https://bgwtest.nihaopay.com/payBackResp/alipay/2a1dc71283c2491294944ba63e4cb914\"&out_trade_no=\"20200924214736955614\"&partner=\"2088101122136241\"&payment_type=\"1\"&product_code=\"NEW_WAP_OVERSEAS_SELLER\"&secondary_merchant_id=\"001100001\"&secondary_merchant_industry=\"4816\"&secondary_merchant_name=\"NihaoPay\"&seller_id=\"2088101122136241\"&service=\"mobile.securitypay.pay\"&subject=\"毛线裤两件\"&total_fee=\"0.01\"&sign=\"LoWPrsjVee9SBIkbCuBYsurJr9tNR3twgLnucOSOAS6crM%2FK4P3Hoxh4rS%2Flt6%2BwehVgGtTGdyuTNwwr4IA2IZ51XgOzGLTD1QC4Pw6GsEVri9dhj4tIbn%2FUHbiQ8gdMoO7qr3vE%2FI9lrOOrneKiNOYVzOcLTAwd9u%2FpB0n1iRM%3D\"&sign_type=\"RSA\"";
                    //orderInfo = "service=\"mobile.securitypay.pay\"&partner=\"2088821558736584\"&out_trade_no=\"AA20200924222310038242388218\"&subject=\"title\"&body=\"paytest\"&total_fee=\"0.01\"&currency=\"CAD\"&payment_type=\"1\"&product_code=\"NEW_WAP_OVERSEAS_SELLER\"&seller_id=\"2088821558736584\"&notify_url=\"http://dev.iotpaycloud.com/v1/alinotify\"&forex_biz=\"FP\"&it_b_pay=\"60m\"&secondary_merchant_id=\"348490533\"&secondary_merchant_name=\"WISHPASS TECHNOLOGY INC.\"&_input_charset=\"utf-8\"&sign=\"vvZsl12ryvvjphjzXe3LIQ9OIsti9Ey6GVs8OxH0r0Pra6rry1pBPgphgIx8aQVPA97TOG6wWP59VNlF%2F4knVRIdHY%2BwDegW9CMfaz8TPVNBjZgtZ5Ht7v1D0KSZZ2p4dh0KXsArFPdfcnS%2FVcxvnSrxIEq4MAbvzMQJbRcpB%2Fg%3D\"&sign_type=\"RSA\"";
                    //orderInfo = "_input_charset=\"utf-8\"&currency=\"USD\"&forex_biz=\"FP\"&it_b_pay=\"2h\"&notify_url=\"https://bgwtest.nihaopay.com/payBackResp/alipay/e92592d446574d1a9fca3cf1b5c713af\"&out_trade_no=\"20200924224018456776\"&partner=\"2088101122136241\"&payment_type=\"1\"&product_code=\"NEW_WAP_OVERSEAS_SELLER\"&secondary_merchant_id=\"001100001\"&secondary_merchant_industry=\"4816\"&secondary_merchant_name=\"NihaoPay\"&seller_id=\"2088101122136241\"&service=\"mobile.securitypay.pay\"&subject=\"NihaoPay\"&total_fee=\"0.01\"&sign=\"IRxUeo1qkREvoqEGeo%2FoqmbQ%2FLB43bTZqD43Oqm5ratubt9viAPD5Xw2c1A%2Bt78cGUk9oJiqW68SCzJdvbiL0102xWiy3Eyr0nUI4AXnt%2FtM7UW%2BoZppnWhO8qeiwo1LooIcohfU%2F6I7WTPliN%2FkkPEEEpWuQTXJ0ugc%2F6Bcxis%3D\"&sign_type=\"RSA\"";
                    PayTask alipay = new PayTask(WXPayEntryActivity.this);
                    Map <String,String> result = alipay.payV2(orderInfo,true);
                    Message msg = new Message();
                    msg.what = SDK_PAY_FLAG;
                    msg.obj = result;
                    mHandler.sendMessage(msg);

                }
            });
        }else if(sTo.equals("WeChat")){

            client.newCall(request).enqueue(new Callback() {
                @Override
                public void onFailure(Call call, IOException e) {
                    e.printStackTrace();
                }
                @Override
                public void onResponse(Call call, final Response response) throws IOException {

                    String orderInfo = response.body().string();
                    editText.setText(orderInfo);
                    JSONObject json = null;
                    try {
                        json = new JSONObject(orderInfo);
                        if(null != json && json.has("packageValue") ){
                            PayReq req = new PayReq();

                            JSONObject payParams = null;
                            {
                                String sTmp = "appId";
                                if(json.has(sTmp)) {
                                    req.appId = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "timeStamp";
                                if(json.has(sTmp)) {
                                    req.timeStamp = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "packageValue";
                                if(json.has(sTmp)) {
                                    req.packageValue = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "sign";
                                if(json.has(sTmp)) {
                                    req.sign = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "prepayId";
                                if(json.has(sTmp)) {
                                    req.prepayId = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "partnerId";
                                if(json.has(sTmp)) {
                                    req.partnerId = json.getString(sTmp);
                                }
                            }
                            {
                                String sTmp = "nonceStr";
                                if(json.has(sTmp)) {
                                    req.nonceStr = json.getString(sTmp);
                                }
                            }




                            //req.extData			= "app data"; // optional
                            msgApi.unregisterApp();
                            msgApi.registerApp(req.appId);
                            msgApi.sendReq(req);




                        /*if(null != json && !json.has("retcode") ){
                            PayReq req = new PayReq();

                            JSONObject payParams = null;
                            if(json.has("payParams")) {
                                payParams = json.getJSONObject("payParams");
                            }else if(json.has("retParams")){
                                payParams = json.getJSONObject("retParams");
                            }
                            if(payParams !=null){
                                if(payParams.has("appId"))req.appId			= payParams.getString("appId");
                                if(payParams.has("timeStamp"))req.timeStamp		= payParams.getString("timeStamp");
                                if(payParams.has("packageValue"))req.packageValue	= payParams.getString("packageValue");
                                if(payParams.has("sign"))req.sign			= payParams.getString("sign");
                                if(payParams.has("prepayId"))req.prepayId		= payParams.getString("prepayId");
                                if(payParams.has("partnerId"))req.partnerId		= payParams.getString("partnerId");
                                if(payParams.has("nonceStr"))req.nonceStr		= payParams.getString("nonceStr");
                            }*/



                            //req.extData			= "app data"; // optional
                            msgApi.unregisterApp();
                            msgApi.registerApp(req.appId);
                            msgApi.sendReq(req);

                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            });
        }else if(sTo.equals("UnionPay")){
            client.newCall(request).enqueue(new Callback() {
                @Override
                public void onFailure(Call call, IOException e) {
                }
                @Override
                public void onResponse(Call call, final Response response) throws IOException {

                    final String obj = response.body().string();
                    if (obj == null || obj.length() == 0) {
                        mainActivity.runOnUiThread(
                                () -> Toast.makeText(WXPayEntryActivity.this, "No Response",Toast.LENGTH_LONG).show()
                        );
                    } else if(obj.indexOf("Fail") == 0) {
                        mainActivity.runOnUiThread(
                                () -> Toast.makeText(WXPayEntryActivity.this, obj,Toast.LENGTH_LONG).show()
                        );

                    } else {

                        mainActivity.runOnUiThread(
                                () -> {
                                    UPPayAssistEx.startPay(getApplicationContext(), null, null, obj, mMode);
                                    String atest = "";
                                }
                        );


                    }

                }
            });
        }
    }

    @Override
    protected void onDestroy() {
        msgApi.unregisterApp();
        super.onDestroy();
    }

    @Override
    public void onReq(BaseReq baseReq) {

    }

    @Override
    public void onResp(BaseResp baseResp) {
        System.out.println("On response");
        System.out.println(baseResp.errCode);
        System.out.println(baseResp.errStr);
        System.out.println(baseResp.openId);

    }
}
